# Create a dictionary with all the major bones with their head and tail empties.
# Also add variables to store each frame bone lengths, the median and the stdev.

BONE_DEFINITIONS = {
    'pelvis.R': {
        'head': 'hips_center',
        'tail': 'right_hip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'pelvis.L': {
        'head': 'hips_center',
        'tail': 'left_hip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'spine': {
        'head': 'hips_center',
        'tail': 'trunk_center',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'spine.001': {
        'head': 'trunk_center',
        'tail': 'neck_center',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'neck': {
        'head': 'neck_center',
        'tail': 'head_center',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'head_nose': {  # Auxiliary bone from head center to nose tip to align the face bones
        'head': 'head_center',
        'tail': 'nose',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'shoulder.R': {
        'head': 'neck_center',
        'tail': 'right_shoulder',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'shoulder.L': {
        'head': 'neck_center',
        'tail': 'left_shoulder',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'upper_arm.R': {
        'head': 'right_shoulder',
        'tail': 'right_elbow',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'upper_arm.L': {
        'head': 'left_shoulder',
        'tail': 'left_elbow',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'forearm.R': {
        'head': 'right_elbow',
        'tail': 'right_wrist',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'forearm.L': {
        'head': 'left_elbow',
        'tail': 'left_wrist',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'hand.R': {
        'head': 'right_wrist',
        'tail': 'right_index',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'hand.L': {
        'head': 'left_wrist',
        'tail': 'left_index',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.carpal.R': {  # Auxiliary bone to align the right_hand_thumb_cmc empty
        'head': 'right_hand_wrist',
        'tail': 'right_hand_thumb_cmc',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.carpal.L': {  # Auxiliary bone to align the left_hand_thumb_cmc empty
        'head': 'left_hand_wrist',
        'tail': 'left_hand_thumb_cmc',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.01.R': {
        'head': 'right_hand_thumb_cmc',
        'tail': 'right_hand_thumb_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.01.L': {
        'head': 'left_hand_thumb_cmc',
        'tail': 'left_hand_thumb_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.02.R': {
        'head': 'right_hand_thumb_mcp',
        'tail': 'right_hand_thumb_ip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.02.L': {
        'head': 'left_hand_thumb_mcp',
        'tail': 'left_hand_thumb_ip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.03.R': {
        'head': 'right_hand_thumb_ip',
        'tail': 'right_hand_thumb_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thumb.03.L': {
        'head': 'left_hand_thumb_ip',
        'tail': 'left_hand_thumb_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.01.R': {
        'head': 'right_hand_wrist',
        'tail': 'right_hand_index_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.01.L': {
        'head': 'left_hand_wrist',
        'tail': 'left_hand_index_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.01.R': {
        'head': 'right_hand_index_finger_mcp',
        'tail': 'right_hand_index_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.01.L': {
        'head': 'left_hand_index_finger_mcp',
        'tail': 'left_hand_index_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.02.R': {
        'head': 'right_hand_index_finger_pip',
        'tail': 'right_hand_index_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.02.L': {
        'head': 'left_hand_index_finger_pip',
        'tail': 'left_hand_index_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.03.R': {
        'head': 'right_hand_index_finger_dip',
        'tail': 'right_hand_index_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_index.03.L': {
        'head': 'left_hand_index_finger_dip',
        'tail': 'left_hand_index_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.02.R': {
        'head': 'right_hand_wrist',
        'tail': 'right_hand_middle_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.02.L': {
        'head': 'left_hand_wrist',
        'tail': 'left_hand_middle_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.01.R': {
        'head': 'right_hand_middle_finger_mcp',
        'tail': 'right_hand_middle_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.01.L': {
        'head': 'left_hand_middle_finger_mcp',
        'tail': 'left_hand_middle_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.02.R': {
        'head': 'right_hand_middle_finger_pip',
        'tail': 'right_hand_middle_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.02.L': {
        'head': 'left_hand_middle_finger_pip',
        'tail': 'left_hand_middle_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.03.R': {
        'head': 'right_hand_middle_finger_dip',
        'tail': 'right_hand_middle_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_middle.03.L': {
        'head': 'left_hand_middle_finger_dip',
        'tail': 'left_hand_middle_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.03.R': {
        'head': 'right_hand_wrist',
        'tail': 'right_hand_ring_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.03.L': {
        'head': 'left_hand_wrist',
        'tail': 'left_hand_ring_finger_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.01.R': {
        'head': 'right_hand_ring_finger_mcp',
        'tail': 'right_hand_ring_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.01.L': {
        'head': 'left_hand_ring_finger_mcp',
        'tail': 'left_hand_ring_finger_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.02.R': {
        'head': 'right_hand_ring_finger_pip',
        'tail': 'right_hand_ring_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.02.L': {
        'head': 'left_hand_ring_finger_pip',
        'tail': 'left_hand_ring_finger_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.03.R': {
        'head': 'right_hand_ring_finger_dip',
        'tail': 'right_hand_ring_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_ring.03.L': {
        'head': 'left_hand_ring_finger_dip',
        'tail': 'left_hand_ring_finger_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.04.R': {
        'head': 'right_hand_wrist',
        'tail': 'right_hand_pinky_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'palm.04.L': {
        'head': 'left_hand_wrist',
        'tail': 'left_hand_pinky_mcp',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.01.R': {
        'head': 'right_hand_pinky_mcp',
        'tail': 'right_hand_pinky_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.01.L': {
        'head': 'left_hand_pinky_mcp',
        'tail': 'left_hand_pinky_pip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.02.R': {
        'head': 'right_hand_pinky_pip',
        'tail': 'right_hand_pinky_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.02.L': {
        'head': 'left_hand_pinky_pip',
        'tail': 'left_hand_pinky_dip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.03.R': {
        'head': 'right_hand_pinky_dip',
        'tail': 'right_hand_pinky_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'f_pinky.03.L': {
        'head': 'left_hand_pinky_dip',
        'tail': 'left_hand_pinky_tip',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thigh.R': {
        'head': 'right_hip',
        'tail': 'right_knee',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'thigh.L': {
        'head': 'left_hip',
        'tail': 'left_knee',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'shin.R': {
        'head': 'right_knee',
        'tail': 'right_ankle',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'shin.L': {
        'head': 'left_knee',
        'tail': 'left_ankle',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'foot.R': {
        'head': 'right_ankle',
        'tail': 'right_foot_index',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'foot.L': {
        'head': 'left_ankle',
        'tail': 'left_foot_index',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'heel.02.R': {
        'head': 'right_ankle',
        'tail': 'right_heel',
        'lengths': [],
        'median': 0,
        'stdev': 0},
    'heel.02.L': {
        'head': 'left_ankle',
        'tail': 'left_heel',
        'lengths': [],
        'median': 0,
        'stdev': 0},
}
